import os

from enum import Enum
from functools import partial

from .tinystories import TinyStoriesDataset
from .wikitext103 import WikiText103Dataset
from .line_ds import LineDataset


class Datasets(Enum):

    WIKITEXT103 = WikiText103Dataset
    TINYSTORIES = TinyStoriesDataset

    TEST_DS = partial(LineDataset, path=os.getenv("TEST_DATASET_PATH", default='tests/fixtures/sample.txt'))

    def __call__(self, **kwargs):
        return self.value(**kwargs)